<!-- eslint-disable vue/no-v-html -->
<template>
  <v-card v-if="item.id" class="showcase-card mx-auto">
    <router-link
      :to="{
        name: 'CorpusTable',
        params: { corpusId: slicePath(item.path) },
      }"
    >
      <v-card-title class="showcase-card-title">
        <span class="mx-auto">{{ item.getShortTitle($i18n.locale) }}</span>
      </v-card-title>
      <div class="showcase-card-image">
        <v-img
          :src="item.imageCard" :alt="item.title"
          :max-height="150"
        />
      </div>
    </router-link>
    <div class="showcase-card-text">
      <span v-html="computeMd(item.getMotto($i18n.locale))" />
    </div>
    <div v-if="item.showcaseName" class="showcase-card-footer">
      <router-link :to="`/~${item.path}${item.showcase}`">
        {{ item.showcaseName }}
      </router-link>
    </div>
  </v-card>
  <v-card
    v-else class="showcase-card px-12 mx-auto"
    :style="`background-color: ${item.color}`"
  >
    <router-link :to="item.link">
      <div
        class="generic-metadata showcase-card-text-generic"
        v-html="optimizeBreaks(item.metadata)"
      />
      <div class="generic-title showcase-card-text-generic">
        <span class="text-center">{{ item.title }}</span>
      </div>
      <div
        class="generic-metadata showcase-card-text-generic"
        v-html="optimizeBreaks(item.metadatatwo)"
      />
    </router-link>
  </v-card>
</template>

<script lang="ts">
import { marked } from 'marked';
import type { Client } from '@/client';
import type CorpusData from '@/data/CorpusData';
import {
  Component, Prop, Vue,
} from 'vue-property-decorator';

export interface ShowcaseCard {
  title: string;
  metadata: string;
  metadatatwo: string;
  link: string;
  color: string;
}

@Component
export default class ShowcaseItem extends Vue {
  @Prop({ required: true })
  item!: ShowcaseCard | CorpusData;

  @Prop({ required: true })
  client!: Client;

  loading = false;

  localizedShowcaseName: string | null = null;

  computeMd(str: string) {
    return marked.parse(str);
  }

  slicePath(path: string): string {
    return path.slice(1, path.length - 1);
  }

  optimizeBreaks(str: string): string {
    // now forbid breaks, except commas
    // see also https://stackoverflow.com/questions/5392853/denoting-a-preferred-place-for-a-line-break
    return str.replace(/ /g, '&nbsp;').replace(/-/g, '&#8209;').replace(/,&nbsp;/g, ', ');
  }
}
</script>

<style lang="scss" scoped>
.showcase-card {
  display:flex;
  flex-direction: column;
  justify-content: space-between;
  max-width: 350px;
  height: 100%;
  min-height: 285px;
  overflow: hidden;
  &-title {
    background: #00000088;
    text-align: center;
    color: white;
    font-weight: bold;
    padding-top: 5px;
    padding-bottom: 5px;
    height: 42px;
    z-index: 100;
    position: relative;
    cursor: pointer;
  }
  &-image {
    position:absolute;
    top:0;
    width: 100%;
    height: 150px;
    z-index: 80;
    box-shadow: 0px 2px 10px #0002;
    cursor: pointer;
  }
  &-text {
    margin-top: 107px;
    padding: 20px 15px;
    font-size: 15px;
    &-generic {
      font-size: 25px;
      color: white;
      width:100%;
      margin: 40px 0;
      display: flex;
      align-items: center;
      justify-content: center;
      text-align: center;
      text-wrap: balance;
      &.generic {
        &-metadata {
          font-size: 20px;
        }
      }
    }
  }
  &-footer {
    font-size: 14px;
    background-color: #bbbbbb;
    color: #333333;
    text-align: center;
    padding-top: 3px;
    padding-bottom: 3px;
  }
}
</style>
